#if !defined(_FAST_BUFFERS_DEFS_)

#define _FAST_BUFFERS_DEFS_

#define FAST_VERSION 2

#include "feevts.h"
#include "augererr.h"
#include "dmlib.h"

#define FAST_MODULE "DMFast"

typedef struct {
#if FAST_VERSION>1
  int TotalBuffers ;
#endif
  int OldBuffer,
    NextBuffer,
    UsedBuffers,
    FreeBuffers,
    MaxUsed ;
#if FAST_VERSION>1
  FAST_EVENT buffers[1] ;
#else
  FAST_EVENT buffers[MAX_FAST_BUFFER] ;
#endif
} FAST_BUFFER ;

#if defined(_FAST_BUFFER_LIB_)

FAST_BUFFER *FastBuffer = NULL ;
mh_com *FastModule = NULL ;
error_code FBError ;

#else

extern FAST_BUFFER *FastBuffer ;
extern mh_com *FastModule ;
extern error_code FBError ;

#endif

#if FAST_VERSION>1
error_code FB_init( int nbuffers ) ;
#else
error_code FB_init( void ) ;
#endif
error_code FB_reset( void ) ;
void FB_close( void ) ;
error_code FB_get( FAST_EVENT **) ;
error_code FB_use( FAST_EVENT ** ) ;
error_code FB_free( void ) ;
void FB_finish( void ) ;

#endif
