#if !defined(_SLOW_BUFFERS_DEFS_)

#define _SLOW_BUFFERS_DEFS_

#define SLOW_VERSION 2

#include "feevts.h"
#include "augererr.h"
#include "dmlib.h"

#define SLOW_MODULE "DMSlow"

typedef struct {
#if SLOW_VERSION>1
  int TotalBuffers ;
#endif
  int OldBuffer,
    NextBuffer,
    UsedBuffers,
    FreeBuffers,
    MaxUsed ;
#if SLOW_VERSION>1
  SLOW_EVENT buffers[1] ;
#else
  SLOW_EVENT buffers[MAX_SLOW_BUFFER] ;
#endif
} SLOW_BUFFER ;

#if defined(_SLOW_BUFFER_LIB_)

SLOW_BUFFER *SlowBuffer = NULL ;
mh_com *SlowModule = NULL ;
error_code SBError ;

#else

extern SLOW_BUFFER *SlowBuffer ;
extern mh_com *SlowModule ;
extern error_code SBError ;

#endif

#if SLOW_VERSION>1
error_code FB_init( int nbuffers ) ;
#else
error_code SB_init( void ) ;
#endif
error_code SB_reset( void ) ;
void SB_close( void ) ;
error_code SB_get( SLOW_EVENT **) ;
error_code SB_use( SLOW_EVENT ** ) ;
error_code SB_free( void ) ;
void SB_finish( void ) ;

#endif
