/***************************************************************
  Gestion du buffer des evenements de calibration.
  Le trigger T1 de calibration est automatiquement disable quand il arrive.
  et c'est le process Calib qui le reenable ==> donc il y a un seul evt 
  de calibration a la fois.
  Il n'y meme pas besoin de semaphore d'exclusion mutuelle pour l'acces
  a ce module !
  Tout ce qu'il y a a faire c'est de creer le datamodule.

  Yaka copier la librairie "dmlib.c".

  **************************************************************/
#include <stdio.h>
#include <stdlib.h>

#include <errno.h>
#include <module.h>

#include "cal_defs.h"
#include "callib.h"

static char Name[128] ;

error_code
CalInit( char *name, int size, void **cal_evt )
{
  unsigned short attrev = 0xC000, /* Sharable, Sticky Bit */
    typlang = 0x400; /* Type "data module" */
  unsigned long perm = 0x333; /* RW pour tout le monde */
  error_code ok ;
  /*  char *mname = Name ;*/
  /*  strcpy( Name, CALIBRATION_BUFFER_NAME ) ; */

  if( !(ok = _os_link( &name,
		       (mh_com **)&Cal_module,
		       (void **)cal_evt,
		       &typlang,
		       &attrev)) ) {
    /* the data-module already exists */
    return ok ;
  }
  else if ( !(ok = _os_datmod(
			      name,
			      size,
			      &attrev,
			      &typlang,
			      perm,
			      (void **)cal_evt,
			      (mh_com **)&Cal_module))) {
    /* the data module has just been created */

    return ok ;
  }
  else return ok ;
}

error_code
CalFinish()
{
  if ( Cal_module ) _os_unlink ( Cal_module ) ;
  Cal_module = NULL ;
  return 0 ;
}
